const std = @import("std");
const VkRenderer = @import("vulkan/Renderer.zig");
const meshes = @import("meshes.zig");

var s_vulkan: VkRenderer = undefined;

pub fn init() !void {
    s_vulkan = try VkRenderer.init();
    std.debug.print("Using device: {s}\n", .{s_vulkan.device.getName()});

    meshes.init();
}

pub fn update() !void {
    try s_vulkan.update();
}

pub fn deinit() void {
    meshes.deinit();
    s_vulkan.deinit();
}

pub fn shouldClose() bool {
    return s_vulkan.window.handle.shouldClose();
}
