const std = @import("std");
const UUID = @import("uuid").UUID;
const vk = @import("vulkan");
const Table = @import("../../containers/table.zig").Table;

const Buffer = @import("Buffer.zig");

// TODO memory
var gpa = std.heap.GeneralPurposeAllocator(.{}){};
const allocator = gpa.allocator();

const MTable = Table(UUID, Mesh);
var s_meshes: MTable = undefined;

pub fn init() !void {
    s_meshes = MTable.init(allocator);
}

pub fn deinit() void {
    s_meshes.deinit();
}

pub fn get(id: MTable.Id) ?*Mesh {
    return s_meshes.getPtr(id);
}

pub const Mesh = struct {
    pub const Id = MTable.Id;

    buffer: Buffer,
    vert_count: u32,
};
