const std = @import("std");
const vk = @import("vulkan");

const Device = @import("device.zig").Device;

pub fn createModule(device: *const Device, stage: vk.ShaderStageFlags, shader_code: []align(@alignOf(u32)) const u8, name: [*:0]const u8) !vk.PipelineShaderStageCreateInfo {
    const module = try device.dispatch.createShaderModule(device.handle, &.{
        .flags = .{},
        .code_size = shader_code.len,
        .p_code = std.mem.bytesAsSlice(u32, shader_code).ptr,
    }, null);

    return vk.PipelineShaderStageCreateInfo{
        .flags = .{},
        .stage = stage,
        .module = module,
        .p_name = name,
        .p_specialization_info = null,
    };
}

pub fn deinitModule(device: *const Device, module: vk.ShaderModule) void {
    device.dispatch.destroyShaderModule(device.handle, module, null);
}
